package cn.estsh.i3plus.ext.mes.pcn.apiservice.serviceimpl.step;

import cn.estsh.i3plus.mes.pcn.serviceimpl.fsm.BaseStepService;
import cn.estsh.i3plus.mes.pcn.serviceimpl.fsm.IStepService;
import cn.estsh.i3plus.pojo.base.enumutil.MesPcnEnumUtil;
import cn.estsh.i3plus.pojo.mes.model.StationRequestBean;
import cn.estsh.i3plus.pojo.mes.model.StationResultBean;
import cn.estsh.i3plus.pojo.mes.model.StepResult;
import cn.estsh.impp.framework.boot.util.SpringContextsUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

/**
 * @Description : 保存加工结果工步
 * @Author : wangjie
 **/
@Slf4j
@Service("mesProductionDataSaveStepService")
public class MesProductionDataSaveStepService extends BaseStepService {

    @Override
    public StepResult execute(StationRequestBean reqBean) {

        StationResultBean resultBean = new StationResultBean();

        StepResult stepResult = StepResult.getSuccessComplete();

        //保存开模记录工步
        ((IStepService) SpringContextsUtil.getBean("mesMouldRecordGenerateStepService")).execute(reqBean);

        //保存零件条码信息工步
        ((IStepService) SpringContextsUtil.getBean("mesProductSnSaveStepService")).execute(reqBean);

        //加工异常处理工步【此工步未整改】
        ((IStepService) SpringContextsUtil.getBean("mesProductResultErrorHandleStepService")).execute(reqBean);

        //生成加工记录工步
        ((IStepService) SpringContextsUtil.getBean("mesProductionRecordGenerateStepService")).execute(reqBean);

        //保存装配记录工步
        ((IStepService) SpringContextsUtil.getBean("mesAssemblySaveStepService")).execute(reqBean);

        //生产汇报工步 【此工步未整改】
        //((IStepService) SpringContextsUtil.getBean("mesReportGenerateStepService")).execute(reqBean);

        //保存工单信息工步
        ((IStepService) SpringContextsUtil.getBean("mesWorkOrderSaveStepService")).execute(reqBean);

        return execSuccessCompleteAndSendMsgReturn(reqBean, resultBean.writeDbLog(MesPcnEnumUtil.WORK_CELL_SCAN_MONITOR_LOG_TYPE.PROCESS.getValue()), stepResult, "保存加工结果成功!");

    }

}
